#include<iostream>
#include<string>
#include<sstream>
#include<thread>
#include<mutex>

using namespace std;

mutex m;

thread_local string threadLocalMark; // diffrent in each thread.
string globalMark; // same in each thread, value is the last writen value.



void run() {
	stringstream ss;
	ss << "this thread id is:" << this_thread::get_id();
	threadLocalMark = ss.str();
	globalMark = ss.str();
	while (1)
	{
		m.lock();
		cout << "*****thread id:" << this_thread::get_id() << endl
			<< "globalMark is:" << globalMark << endl
			<< "threadLocalMark" << threadLocalMark << "  *****" << endl;
		m.unlock();
		this_thread::sleep_for(std::chrono::seconds(1));
		
	}
}

void main() {
	thread t(run);
	t.detach();
	run();
}